
// JSON parser start ----------------------------------------------------------
//
// Below is the minified JSON parser from http://json.org/json2.js
// 2010-08-25, Public Domain 
// NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.
if(!this.JSON){this.JSON={};}
(function(){function f(n){return n<10?'0'+n:n;}
if(typeof Date.prototype.toJSON!=='function'){Date.prototype.toJSON=function(key){return isFinite(this.valueOf())?this.getUTCFullYear()+'-'+
f(this.getUTCMonth()+1)+'-'+
f(this.getUTCDate())+'T'+
f(this.getUTCHours())+':'+
f(this.getUTCMinutes())+':'+
f(this.getUTCSeconds())+'Z':null;};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf();};}
var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={'\b':'\\b','\t':'\\t','\n':'\\n','\f':'\\f','\r':'\\r','"':'\\"','\\':'\\\\'},rep;function quote(string){escapable.lastIndex=0;return escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return typeof c==='string'?c:'\\u'+('0000'+a.charCodeAt(0).toString(16)).slice(-4);})+'"':'"'+string+'"';}
function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==='object'&&typeof value.toJSON==='function'){value=value.toJSON(key);}
if(typeof rep==='function'){value=rep.call(holder,key,value);}
switch(typeof value){case'string':return quote(value);case'number':return isFinite(value)?String(value):'null';case'boolean':case'null':return String(value);case'object':if(!value){return'null';}
gap+=indent;partial=[];if(Object.prototype.toString.apply(value)==='[object Array]'){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||'null';}
v=partial.length===0?'[]':gap?'[\n'+gap+
partial.join(',\n'+gap)+'\n'+
mind+']':'['+partial.join(',')+']';gap=mind;return v;}
if(rep&&typeof rep==='object'){length=rep.length;for(i=0;i<length;i+=1){k=rep[i];if(typeof k==='string'){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}else{for(k in value){if(Object.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?': ':':')+v);}}}}
v=partial.length===0?'{}':gap?'{\n'+gap+partial.join(',\n'+gap)+'\n'+
mind+'}':'{'+partial.join(',')+'}';gap=mind;return v;}}
if(typeof JSON.stringify!=='function'){JSON.stringify=function(value,replacer,space){var i;gap='';indent='';if(typeof space==='number'){for(i=0;i<space;i+=1){indent+=' ';}}else if(typeof space==='string'){indent=space;}
rep=replacer;if(replacer&&typeof replacer!=='function'&&(typeof replacer!=='object'||typeof replacer.length!=='number')){throw new Error('JSON.stringify');}
return str('',{'':value});};}
if(typeof JSON.parse!=='function'){JSON.parse=function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==='object'){for(k in value){if(Object.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!==undefined){value[k]=v;}else{delete value[k];}}}}
return reviver.call(holder,key,value);}
text=String(text);cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return'\\u'+
('0000'+a.charCodeAt(0).toString(16)).slice(-4);});}
if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,'@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,']').replace(/(?:^|:|,)(?:\s*\[)+/g,''))){j=eval('('+text+')');return typeof reviver==='function'?walk({'':j},''):j;}
throw new SyntaxError('JSON.parse');};}}());
// JSON parser end ------------------------------------------------------------

var LOGFILE_NAME = "timed-events.log";
var l = new Logger(LOGFILE_NAME);

function pad(n) {
    return n < 10 ? '0' + n: n
}

// parses the recurrence object and generates an array of strings, each
// containing a valid recurrence rule
function generateIcalRules(param)
{
    var rules = [];

    if (param.triggerTime === undefined)
    {
        l.logln("Missing start time parameter!");
        return rules;
    }
        
    var time = param.triggerTime.split(':');
    var d = new Date();
    d.setUTCHours(time[0]);
    d.setUTCMinutes(time[1]);
    d.setUTCSeconds(time[2]);

    if (param.recurrence === 'regular_wk')
    {
        if (time.length != 3)
        {
            l.logln("Invalid start time, expecting hh:mm:ss");
            return rules;
        }

        if ((param.weekdays === undefined) || (param.weekdays.length <= 0))
        {
            l.logln("Missing week days for periodic weekly event settings!");
            return rules;
        }
        var iCalStartTime = d.getFullYear() + '' + pad(d.getMonth() + 1) + '' + 
                   pad(d.getDate()) + 'T' +
                   pad(d.getUTCHours()) + '' + pad(d.getUTCMinutes()) + '' +
                   pad(d.getUTCSeconds()) + 'Z';

        var weekdays = "";
        for (var i = 0; i < param.weekdays.length; i++)
        {
            if (i > 0)
            {
                weekdays = weekdays + ',';
            }
            weekdays = weekdays + param.weekdays[i];
        }

        var rrule = 'FREQ=DAILY;BYDAY=' + weekdays; 

        rules.push({ iCalRRule : rrule, iCalStartTTime : iCalStartTime });
    }
    else if (param.recurrence === 'irregular')
    {
        if ((param.dates === undefined) || (param.dates.length <= 0))
        {
            l.logln("Missing dates for irregular event settings!");
            return rules;
        }


        var rrule = 'FREQ=DAILY;COUNT=1'; 

        for (var i = 0; i < param.dates.length; i++)
        {
            var date = param.dates[i].split('-');
            if (date.length != 3)
            {
                l.logln("Skipping invalid date: " + date);
                return;
            }

            var iCalStartTime = date[2] + date[1] + date[0] + 'T' + 
                            pad(d.getUTCHours()) + pad(d.getUTCMinutes()) + 
                            pad(d.getUTCSeconds()) + 'Z';

            rules.push({ iCalRRule : rrule, iCalStartTTime : iCalStartTime });
        }
        // dSS only accepts ical dates if one provides rrule and start time
    }

    return rules;
}


if (raisedEvent.name == "addtimer") 
{
    var check = true;
    if (raisedEvent.parameter.actions === undefined)
    {
        l.logln("ERROR: missing actions parameter!");
        check = false;
    }

    if (raisedEvent.parameter.recurrence === undefined)
    {
        l.logln("ERROR: missing recurrence parameter!");
        check = false;
    }

    if (check === true)
    {
        var recurrence_params = 
               JSON.parse(decodeURIComponent(raisedEvent.parameter.recurrence));

        var ical_rules = generateIcalRules(recurrence_params);

        for (var i = 0; i < ical_rules.length; i++)
        {
            l.logln("Queing events for timer " + 
                    raisedEvent.parameter.timername);
            var timerEvent = new event("timed_event", 
            {
                iCalRRule: ical_rules[i].iCalRRule,
                iCalStartTime: ical_rules[i].iCalStartTTime,
                actions: raisedEvent.parameter.actions,
                timername: raisedEvent.parameter.timername
            });

            timerEvent.raise();
        }
    }
} 
else if (raisedEvent.name == "timed_event")
{
    l.logln("Processing timer " + raisedEvent.parameter.timername);

    var action_params = 
        JSON.parse(decodeURIComponent(raisedEvent.parameter.actions));

    if (action_params.actions === undefined)
    {
        l.logln("ERROR: missing event actions!");
    }
    else
    {
        for (i = 0; i < action_params.actions.length; i++)
        {
            var action = action_params.actions[i];
            if (action === undefined)
            {
                l.logln("ERROR: received invalid action values!");
                break;
            }

            if (action.unit === 'scene')
            {
                l.logln("Calling scene " + action.scene + " on zone " + 
                        action.zone + " for devices of group " + action.group);
                var s = getDevices().byZone(action.zone).byGroup(action.group);
                s.perform(function(dev) { dev.callScene(action.scene); });
            }
            else if (action.unit === 'group')
            {
                l.logln("Setting value " + action.value + " on zone " +
                        action.zone + " for devices of group " + action.group);
                var s = getDevices().byZone(action.zone).byGroup(action.group);
                s.perform(function(dev) { dev.setValue(action.value); });
            }
        }
    }

}

